"use strict";

exports.__esModule = true;
exports.extractStyleAttrs = void 0;

var _lodash = _interopRequireDefault(require("lodash.camelcase"));

var _styledSystem = require("@chakra-ui/styled-system");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var camelCaseCache = {};
/** Extracts CSS style properties and HTML attributes from merged component attributs */

var extractStyleAttrs = function extractStyleAttrs(styleProps) {
  var styles = {};
  var attrs = {};

  for (var prop in styleProps) {
    var _attr = void 0;

    if (camelCaseCache[prop]) {
      _attr = camelCaseCache[prop];
    } else {
      _attr = "" + (prop.startsWith('_') ? '_' : '') + (0, _lodash["default"])(prop);
      camelCaseCache[prop] = _attr;
    }

    var _isStyledProp = (0, _styledSystem.isStyleProp)(_attr);

    if (_isStyledProp) {
      // @ts-expect-error Not sure how to cast returned string into typeof key of U
      styles[_attr] = styleProps[prop];
    } else {
      // @ts-expect-error Not sure how to cast returned string into typeof key of U
      attrs[prop] = styleProps[prop];
    }
  }

  return {
    styles: styles,
    attrs: attrs
  };
};

exports.extractStyleAttrs = extractStyleAttrs;
//# sourceMappingURL=system.attrs.js.map