import { inject } from 'vue';
import { useColorMode } from '@chakra-ui/c-color-mode';

/** Provides theme object in component context */
export var useTheme = () => {
  var theme = inject('$chakraTheme');
  return theme;
};
/** Single hook to provide theme and color mode values */

export var useChakra = () => {
  var theme = useTheme();
  var {
    colorMode
  } = useColorMode();
  return {
    theme,
    colorMode
  };
};
//# sourceMappingURL=use-chakra.js.map