import camelCase from 'lodash.camelcase';
import { isStyleProp } from '@chakra-ui/styled-system';
var camelCaseCache = {};
/** Extracts CSS style properties and HTML attributes from merged component attributs */

export var extractStyleAttrs = styleProps => {
  var styles = {};
  var attrs = {};

  for (var prop in styleProps) {
    var _attr = void 0;

    if (camelCaseCache[prop]) {
      _attr = camelCaseCache[prop];
    } else {
      _attr = "" + (prop.startsWith('_') ? '_' : '') + camelCase(prop);
      camelCaseCache[prop] = _attr;
    }

    var _isStyledProp = isStyleProp(_attr);

    if (_isStyledProp) {
      // @ts-expect-error Not sure how to cast returned string into typeof key of U
      styles[_attr] = styleProps[prop];
    } else {
      // @ts-expect-error Not sure how to cast returned string into typeof key of U
      attrs[prop] = styleProps[prop];
    }
  }

  return {
    styles,
    attrs
  };
};
//# sourceMappingURL=system.attrs.js.map